package com.link.core.util;

import com.link.core.basic.dao.PushRowId2RedisThreadDao;
import com.link.core.util.redisclient.LinkRedisClient;
import java.util.Date;
import java.util.List;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.jdbc.core.JdbcTemplate;

public class RedisRowIdUtil {
   private static final String MYSQL_ROWID_REDISKEY = "MYSQL_ROWID_CACHE";
   private static final String ORACLE_ROWID_REDISKEY = "ORACLE_ROWID_CACHE";
   private static final Logger logger = LogManager.getLogger(PushRowId2RedisThreadDao.class);

   public static void lpushUncloseJedis(LinkRedisClient jedis, String key, String value) {
      jedis.lpush(key, value);
   }

   public static String rpopUncloseJedis(LinkRedisClient jedis, String key) {
      String value = null;
      List<String> valList = jedis.brpop(0, key);
      value = (String)valList.get(1);
      return value;
   }

   public static long redisRowIdNumByList(LinkRedisClient jedis, String key, long start, long end) {
      long result = 0L;
      result = jedis.llen(key);
      return result;
   }

   public static String getGenerateId(Long currentId) {
      String res = "";
      res = "W-" + Long.toHexString(currentId).toUpperCase();
      return res;
   }

   public static void saddUncloseJedis(LinkRedisClient jedis, String key, String[] value) {
      jedis.sadd(key, value);
   }

   public static String spopUncloseJedis(LinkRedisClient jedis, String key) {
      String value = null;
      value = jedis.spop(key);
      return value;
   }

   public static long redisRowIdNumBySet(LinkRedisClient jedis, String key) {
      long result = 0L;
      result = jedis.scard(key);
      return result;
   }

   public static void generateRedisRowIdByList(JdbcTemplate jdbcTemplate, LinkRedisClient jedis, int generateNum) {
      logger.info("主线程查出redis中的row_id已为空！开始添加row_id。" + DateUtil.dateToStr(new Date(), "HHmmss_SSS"));
      boolean flag = false;
      String id = null;
      String sql1 = "select currentvalue from lnk_seq where seqname = 'S_SEQUENCE_S'";

      for(int i = 0; i < 10; ++i) {
         Long currentId = (Long)jdbcTemplate.queryForObject(sql1, Long.class);
         Long afterId = currentId + (long)generateNum;
         String sql2 = "update lnk_seq set currentvalue = " + afterId + " where seqname = 'S_SEQUENCE_S' and currentvalue = " + currentId;
         int result = jdbcTemplate.update(sql2);
         if (result > 0) {
            flag = true;

            for(int j = 0; j < generateNum; ++j) {
               currentId = currentId + 1L;
               id = getGenerateId(currentId);
               lpushUncloseJedis(jedis, "MYSQL_ROWID_CACHE", id);
            }

            logger.info("主程序添加" + generateNum + "条redis row_id完毕！" + DateUtil.dateToStr(new Date(), "HHmmss_SSS"));
            break;
         }
      }

      if (!flag) {
         logger.info("主程序添加" + generateNum + "条redis row_id失败，其它线程已修改id表！" + DateUtil.dateToStr(new Date(), "HHmmss_SSS"));
      }

   }

   public static void generateRedisRowIdBySet(JdbcTemplate jdbcTemplate, LinkRedisClient jedis, int generateNum, String processName) {
      logger.info(processName + "查出redis中的row_id已为空！开始添加row_id。" + DateUtil.dateToStr(new Date(), "HHmmss_SSS"));
      boolean flag = false;
      String sql1 = "select currentvalue from lnk_seq where seqname = 'S_SEQUENCE_S'";

      for(int i = 0; i < 10; ++i) {
         Long currentId = (Long)jdbcTemplate.queryForObject(sql1, Long.class);
         Long afterId = currentId + (long)generateNum;
         String sql2 = "update lnk_seq set currentvalue = " + afterId + " where seqname = 'S_SEQUENCE_S' and currentvalue = " + currentId;
         int result = jdbcTemplate.update(sql2);
         if (result > 0) {
            flag = true;
            String[] ids = new String[generateNum];

            for(int j = 0; j < generateNum; ++j) {
               currentId = currentId + 1L;
               ids[j] = getGenerateId(currentId);
            }

            saddUncloseJedis(jedis, "MYSQL_ROWID_CACHE", ids);
            logger.info(processName + "添加" + generateNum + "条redis row_id完毕！" + DateUtil.dateToStr(new Date(), "HHmmss_SSS"));
            break;
         }
      }

      if (!flag) {
         logger.info(processName + "添加" + generateNum + "条redis row_id失败，其它线程已修改id表！" + DateUtil.dateToStr(new Date(), "HHmmss_SSS"));
      }

   }
}
